"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = __importStar(require("commander"));
const exchanges = ['bitfinex', 'bittrex', 'kraken', 'kyber', 'uniswap'];
const installed = exchanges.reduce((carry, current) => {
    try {
        const dependency = `@melonproject/ea-${current}`;
        const cli = require.resolve(`${dependency}/lib/cli`);
        return Object.assign(Object.assign({}, carry), { [current]: cli });
    }
    catch (e) {
        // The module is not installed.
    }
    return carry;
}, {});
Object.keys(installed).forEach(exchange => {
    const dependency = installed[exchange];
    commander_1.default
        .command(exchange)
        .action(() => {
        const program = new commander_1.Command();
        const args = process.argv.slice(1);
        require(dependency).default(program, args);
    })
        .allowUnknownOption();
});
commander_1.default.on('command:*', () => {
    commander_1.default.help();
    process.exit(1);
});
commander_1.default.parse(process.argv);
if (!commander_1.default.args.length) {
    commander_1.default.help();
    process.exit(1);
}
